#include <stdlib.h>

#include "m_bbox.h"
#include "m_random.h"
#include "i_system.h"

#include "doomdef.h"
#include "p_maputl.h"

#include "s_sound.h"

#include "d_chase.h"

// State.
#include "doomstat.h"
//included r_local

// Data.
#include "sounds.h"



extern mobj_t*		shootthing;
extern fixed_t		shootz;	

extern int		la_damage;
extern fixed_t		attackrange;

extern fixed_t		aimslope;

// slopes to top and bottom of target
extern fixed_t	topslope;
extern fixed_t	bottomslope;	

fixed_t xloc = 0;
fixed_t yloc = 0;
fixed_t zloc = 0;

//
// PTR_CamTraverse
//
boolean PTR_CamTraverse (intercept_t* in)
{
    fixed_t		x;
    fixed_t		y;
    fixed_t		z;
    fixed_t		frac;
    
    line_t*		li;
    
    fixed_t		slope;
    fixed_t		slope2;
    fixed_t		slopehigh;
    fixed_t		dist;
    int checktop;
	int checkbottom;
	
	checktop = checkbottom = 0;
	
	
    if (in->isaline)
    {
	li = in->d.line;

	if ( !(li->flags & ML_TWOSIDED) )
	    goto nope;
	
	// crosses a two sided line
	P_LineOpening (li);
		
	dist = FixedMul (attackrange, in->frac);

    if (li->frontsector->floorheight != li->backsector->floorheight)
		checkbottom = 1;
		
	if (li->frontsector->ceilingheight != li->backsector->ceilingheight)
		checktop = 1;
    
    slope = FixedDiv (openbottom - shootz , dist);
    slope2 = FixedDiv (opentop - shootz , dist);
    slopehigh = FixedDiv (opentop - shootz - FRACUNIT * 14, dist);
    
    if (openrange < 8)
    	goto hitline;
    if (aimslope > slopehigh && li->backsector->ceilingheight < li->frontsector->ceilingheight && checktop)
		goto nope;
    
    if (slopehigh < aimslope && slopehigh < upslope && slopehigh > downslope)
	{    	
    	aimslope = FixedDiv (opentop - shootz - 14 * FRACUNIT , dist);
    	goto hitline;
    }
	if (li->backsector->ceilingheight < li->frontsector->ceilingheight && slope2 < aimslope && checktop)
		goto hitline;    
	if (li->backsector->floorheight > li->frontsector->floorheight && slope > aimslope && checkbottom)
		goto hitline;
	// shot continues
	return true;
	
	
	// hit line
      hitline:
	
    if (downslope > slope2 && checkbottom)
    	goto nope;
    if (upslope < slope && checktop)
    	goto nope;
    
    if (upslope > slope2 && checktop)
    	upslope = slope2;
    if (downslope < slope && checkbottom)
    	downslope = slope;
	
	if (aimslope > slope2 && li->frontsector->ceilingheight > li->backsector->ceilingheight)
		goto nope;
	if (aimslope < slope && li->frontsector->floorheight < li->backsector->floorheight)
		goto nope;
	
	frac = in->frac - FixedDiv (4*FRACUNIT,attackrange);
	x = trace.x + FixedMul (trace.dx, frac);
	y = trace.y + FixedMul (trace.dy, frac);
	z = shootz + FixedMul (aimslope, FixedMul(frac, attackrange));
    xloc = x;
    yloc = y;
    zloc = z;
    maxout = 3;
	return true;
	
	nope:
	frac = in->frac - FixedDiv (4*FRACUNIT,attackrange);
	x = trace.x + FixedMul (trace.dx, frac);
	y = trace.y + FixedMul (trace.dy, frac);
	z = shootz + FixedMul (aimslope, FixedMul(frac, attackrange));
    xloc = x;
    yloc = y;
    zloc = z;
    maxout = 1;
	return false;
	}
	return true;
}


mobj_t*
P_CamMax
( mobj_t*	t1,
  angle_t	angle,
  angle_t	heightangle,
  fixed_t	distance)
{
    
    
    fixed_t	x2;
    fixed_t	y2;
	
	maxout = 0;
    angle >>= ANGLETOFINESHIFT;
    heightangle >>= ANGLETOFINESHIFT;
    shootthing = t1;
    la_damage = 0;
    x2 = t1->x + (distance>>FRACBITS)*finecosine[angle];
    y2 = t1->y + (distance>>FRACBITS)*finesine[angle];
    shootz = t1->z + (t1->height>>1) + 8*FRACUNIT;
    attackrange = distance;
    aimslope = finesine[heightangle];
	upslope = 65535;	
	downslope = -65535;
		
    P_PathTraverse ( t1->x, t1->y,
		     x2, y2,
		     PT_ADDLINES,
		     PTR_CamTraverse );
	puffloc->x = xloc;
	puffloc->y = yloc;
	puffloc->z = zloc;
	if (maxout == 1)
		puffloc->health = 100;
	else if (maxout == 3)
	{
	puffloc->health = 101;
	puffloc->z = shootz + FixedMul (aimslope, distance);
	}
	else
		puffloc->health = 0;
	return puffloc;
}
