#ifdef NORMALUNIX
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#endif
#include <allegro.h>
#include <ctype.h>                    
#include <conio.h>
                    
#include "doomdef.h"
#include "doomstat.h"

#include "dstrings.h"
#include "sounds.h"


#include "z_zone.h"
#include "w_wad.h"
#include "s_sound.h"


#include "f_finale.h"
#include "f_wipe.h"

#include "m_argv.h"
#include "m_misc.h"
#include "m_menu.h"

#include "i_system.h"
#include "i_sound.h"
#include "i_video.h"

#include "g_game.h"

#include "hu_stuff.h"
#include "wi_stuff.h"
#include "st_stuff.h"
#include "am_map.h"

#include "p_setup.h"


#include "d_main.h"

#include "d_chase.h"


void ReadInstructionFile (int verbosity)
{
FILE * handle;
char    *file;
char    *infile;
int      size;
int		pos;
int		posword;
int x;
char	instruct[127];
char    built[127];
int 	assignnext = 0;
int		saynext = 0;
int 	enact = 1;
int		loopdepth = 0;
int		terminated = 0;
int		assignvalue;
	    
handle = fopen("cam.cfg","rb");
if (!handle)
	return;
if (verbosity)
	{
	printf("Found Advanced Config File cam.cfg\n");
	printf("Reading...\n\n");
	}
fseek (handle,0,SEEK_END);
size = ftell(handle);
fseek (handle,0,SEEK_SET);
file = malloc (size);
fread (file,size,1,handle);
fclose (handle);
pos = 0;
infile = file;
posword = 0;
// Go thru whole file
for (pos = 0; pos < size; pos=pos+posword+1)
{
	// BUILD WORD:
 	for (x=0;x<=50;x++) // Clear out old word
		built[x]=' ';
		
	posword = 0;
 	instruct[posword] = *(infile+posword+pos);
 	while (instruct[posword] > ' ' && instruct[posword] <= 'z' && instruct[posword] !=';')
 	{
		posword++;
 		instruct[posword] = *(infile+posword+pos);
 	}
 	if (posword == 0)
 		continue;
	
	for (x=0;x<posword;x++)
		built[x]=instruct[x];
 	built[posword] = '\0';
 	// Parse word
	
	/*
	if (!strcmp(built, COMMENT)) // If comment marks:
	{
		enact = 1 - enact; // Toggle comment mode
		continue;
	}
	if (!enact)
		continue;
	
	if (loopdepth == 0) // Look for :BEGIN marker
	{
		if (!strcmp(built, BEGINLOOP))
			loopdepth = 1;
		continue;
	}
		
	if (!strcmp(built, ENDLOOP)) // Look for :END marker
	{
		terminated = 1;
		break;
	}
	
	if (saynext)
	{
		//if (verbosity)
		printf("%s\n", built);
		saynext = 0;
		continue;
	}
	*/
	if (assignnext)
	{
		if (strlen(built) == 1 && assignnext == 1)
			assignvalue = *built;
		else
			assignvalue = atoi((char*)built);
		if (assignnext == 1)
		{
			key_cam = assignvalue;
			if (verbosity)
			{
			if(isgraph(assignvalue))
				printf("CamToggleKey = %c\n", assignvalue);
			else
				printf("CamToggleKey = %i\n", assignvalue);
			}
		}
		if (assignnext == 2)
		{
			CamTypeSetVar = assignvalue;
			if (verbosity)
				printf("CamState = %i\n", assignvalue);
		}
		if (assignnext == 3)
		{
			HeightAngleSetVar = assignvalue;
			if (verbosity)
				printf("HeightAngle = %i\n", assignvalue);
		}
		if (assignnext == 4)
		{
			CamAngleSetVar = assignvalue;
			if (verbosity)
				printf("CamAngle = %i\n", assignvalue);
		}
		if (assignnext == 5)
		{
			IdealDistSetVar = assignvalue;
			if (verbosity)
				printf("CamDist = %i\n", assignvalue);
		}
		assignnext = 0;
		continue;
	}
	if (!strcmp(built, D_Say))
	{
		saynext = 1;
		continue;
	}	
	if (!stricmp(built, D_CamToggleKey))
	{
		assignnext = 1;
	 	continue;
	}
	if (!stricmp(built, D_CamState))
	{
		assignnext = 2;
	 	continue;
	}
	if (!stricmp(built, D_CamHeight))
	{
		assignnext = 3;
	 	continue;
	}
	if (!stricmp(built, D_CamAngle))
	{
		assignnext = 4;
	 	continue;
	}
	if (!stricmp(built, D_CamDist))
	{
		assignnext = 5;
	 	continue;
	}
	printf("Unknown command: %s\n", built);
}
if (verbosity)
	{
	printf("cam.cfg file loaded successfully.  Hit a key...");
	getchar();
	}
}

//
// AKMARKER: Complement hack to above:  defaults.
void SetDefaults (void)
{
percentideal = 0;
ccmode = 0;
oneticb = 1;
}

void ChaseParm ( void )
{
camState = 0;
camMaxState = 2;
if ( M_CheckParm ("-chase") )
{
   	percentideal = 100;
   	chasecamon = true;
   	ccmode = 2;
   	camState = 1;
}

}


void D_ChaseInit(void)
{
SetDefaults();

//Steve Boom.cfg frad!
//ReadInstructionFile(M_CheckParm ("-verbose"));

ChaseParm();
}
