//PrjDOOM code module for p_* code modules
//
//This module contains:
//
//Sloshing Water

#include "doomstat.h"
#include "s_sound.h"
#include "sounds.h"
#include "d_deh.h"  
#include "r_data.h"
#include "p_prjdm.h"
#include "p_inter.h"
#include "p_user.h"
#include "p_mobj.h"
#include "debug.h"

static const char
rcsid[] = "$Id: p_prjdm.c,v 1.63 1999/1/18 06:59:50 Steve Exp $";

void P_PlayerSlosh(sector_t* sec, player_t* player)
{
 if(sloshon)
 {
       if( 
         ((sec->floorpic == R_FlatNumForName( "FWATER1")) ||
          (sec->floorpic == R_FlatNumForName( "FWATER2")) ||
          (sec->floorpic == R_FlatNumForName( "FWATER3")) ||
          (sec->floorpic == R_FlatNumForName( "FWATER4"))) &&
          onground) 
        inwater = 1;
       else 
        inwater = 0;
  
       if(player->mo->momx || player->mo->momy)
        playermov = 1;
       else 
        playermov = 0;

  if(inwater == 1) 
   {
    if(lastwater == 0)
     S_StartSound (player->mo, sfx_inwatr); //Big splash when first get in water

    lastwater = 1;
    if(playermov == 1) 
    {
     timer++;
     switch(timer)
     {
      case  70:
       S_StartSound (player->mo, sfx_wade1);  //These will be different
       break;                                 //water sounds, just to
      case 140:                                //add flavor
       S_StartSound (player->mo, sfx_wade2);
       break;
      case 210:
       S_StartSound (player->mo, sfx_wade3);
       timer = 0;
       break;
     }
    }
   }
  else
  {
   if(lastwater == 1 && inwater == 0) 
    S_StartSound (player->mo, sfx_outwtr); //Sound as you leave water
   lastwater = 0;
  }
 }
}

void P_FallDamage(player_t* player)
{
 int damage; 
 if(!compatibility && !demo_compatibility)
 {
  if(falldamage)
  {
   if(onground)
   {
    if(inaircount > 18)
    {
     damage = inaircount * 2;
     P_DamageMobj(player->mo, NULL, NULL, damage);
    }
    inaircount = 0;
   }
   else
    inaircount++;
  }
 }
}

void P_DeathMessages(mobj_t* source, mobj_t* target)
{
  //Player Death Message Code -Steve
  
  char end[80], finalmsg[80]; 

  if(dmessages)
  {
   switch (source->type)
   {
    case MT_POSSESSED:
     strcpy(end, s_DM_POSSESSED);
     break;
    case MT_SHOTGUY:
     strcpy(end, s_DM_SHOTGUY);
     break;
    case MT_FIRE:
    case MT_VILE:
     strcpy(end, s_DM_VILE);
     break;
    case MT_UNDEAD:
     strcpy(end, s_DM_UNDEAD);
     break;
    case MT_TRACER:
     strcpy(end, s_DM_TRACER);
     break;
    case MT_FATSO:
     strcpy(end, s_DM_FATSO);
     break;
    case MT_FATSHOT:
     strcpy(end, s_DM_FATSHOT);
     break;
    case MT_CHAINGUY:
     strcpy(end, s_DM_CHAINGUY);
     break;
    case MT_TROOP:
     strcpy(end, s_DM_TROOP);
     break;
    case MT_SERGEANT:
     strcpy(end, s_DM_SERGEANT);
     break;
    case MT_SHADOWS:
     strcpy(end, s_DM_SHADOWS);
     break;
    case MT_HEAD:
     strcpy(end, s_DM_HEAD);
     break;
    case MT_KNIGHT:
    case MT_BRUISERSHOT:
    case MT_BRUISER:
     strcpy(end, s_DM_BRUISER);
     break;
    case MT_SKULL:
     strcpy(end, s_DM_SKULL);
     break;
    case MT_SPIDER:
     strcpy(end, s_DM_SPIDER);
     break;
    case MT_BABY:
     strcpy(end, s_DM_BABY);
     break;
    case MT_CYBORG:
     strcpy(end, s_DM_CYBORG);
     break;
    case MT_PAIN:
     strcpy(end, s_DM_PAIN);
     break;
    case MT_WOLFSS:
     strcpy(end, s_DM_WOLFSS);
     break;
    default:
     strcpy(end, s_DM_DEFAULT);
     break;
   }

   WriteDebugFile( "Message is..." );
   
   sprintf(finalmsg, "player %s", end);

   WriteDebugFile( finalmsg );

   target->player->message = finalmsg;
  }
}
